/**
 * Задание 1.
 *
 * Написать функцию-сумматор.
 * Функция обладает двумя числовыми параметрами, и возвращает результат их сложения.
 */

// function summ(a,b){
//     return a + b ;

// }
// console.log(summ (5,4));

/**
 * Задание 2.
 *
 * Написать функцию, которая определяет количество переданных аргументов, и возвращает их количество.
 */


//  function arg() {
//     return arguments.length
// }

// console.log(arg('Alice', 'Bob', 'Taras'))

/**
 * Задание 3.
 *
 * Написать функцию-счётчик count.
 *
 * Функцию обладает будет двумя параметрами:
 * - Первый — число, с которого необходимо начать счёт;
 * - Второй — число, которым необходимо закончить счёт.
 *
 * Если число, с которого начинается счёт больше, чем число,
 * которым он заканчивается, вывести сообщение:
 * «⛔️ Ошибка! Счёт невозможен.»
 * 
 * Если оба этих числа одинаковые, вывести сообщение:
 * «⛔️ Ошибка! Нечего считать.»
 *
 * В начале счёта необходимо вывести сообщение:
 * «🏁 Отсчёт начат.».
 *
 * Каждый «шаг» счёта необходимо выводить в консоль.
 * После прохождения последнего «шага» необходимо вывести сообщение:
 * «✅ Отсчёт завершен.».
 *
 */

// function count(start, end) {
//     if (start > end){
//         console.log('⛔️ Ошибка! Счёт невозможен.');
//     }
//     else if (start === end)
//     console.log('⛔️ Ошибка! Нечего считать.');
//     else{
//     console.log('🏁 Отсчёт начат.')
//     for (let i = start; i <= end ; i++){
//     console.log(i);}
//     console.log('✅ Отсчёт завершен.');
// }
// }

// count (8, 34)


// const showMessage = function () {
//     console.log('Massage');
// }
// showMessage();


/**
 * Задание 4.
 *
 * Написать улучшенную функцию-счётчик countAdvanced.
 *
 * Функцию-счётчик из предыдущего задания расширить дополнительным функционалом:
 * - Добавить ей третий параметр, и выводить в консоль только числа, кратные значению из этого параметра;
 * - Генерировать ошибку (throw new Error), если функция была вызвана не с тремя аргументами;
 * - Генерировать ошибку, если любой из аргументов не является допустимым числом.
 */



function countAdvanced(start, end, step) {
    if (arguments.length !== 3) {
        throw new Error('Ошибка')
    }
    if (isNaN(start)
        || isNaN(end)
        || isNaN(step)
        || typeof start !== 'number'
        || typeof end !== 'number'
        || typeof step !== 'number') {
        throw new Error('Передайте 3 аргумента')
    }
    if (start > end) {
        console.log('⛔️ Ошибка! Счёт невозможен.');
    } else if (start === end) {
        console.log('⛔️ Ошибка! Нечего считать.');
    } else {
        console.log('🏁 Отсчёт начат.')
        for (let i = start; i <= end; i++) {
            if (i % step === 0) {
                console.log(i);
            }

        }
        console.log('✅ Отсчёт завершен.');
    }
}

countAdvanced(10, 20, 2)